package AnyEvent::HTTP::Server::Kit;


BEGIN {
	defined ${^WARNING_BITS}
		?	${^WARNING_BITS} ^= ${^WARNING_BITS} ^ "\xfc\x3f\xf3\x00\x0f\xf3\xcf\xc0\xf3\xfc\x33\x03\x3f\x00\x0c\x00\x00\x00\x00"
		:	${^WARNING_BITS} = "\xfc\x3f\xf3\x00\x0f\xf3\xcf\xc0\xf3\xfc\x33\x03\x3f\x00\x0c\x00\x00\x00\x00";
	$^H |= 0x1c0206e2;

	$^H{'feature_say'} = 1;
	$^H{'feature_state'} = 1;
	$^H{'feature_indirect'} = 1;
	$^H{'feature_switch'} = 1;
}
m{
use strict;
use warnings;
}x;

use Scalar::Util 'weaken', 'refaddr';

BEGIN {
	for my $sub (qw(carp croak confess)) {
		no strict 'refs';
		*$sub = sub {
			my $caller = caller;
			local *__ANON__ = $caller .'::'. $sub;
			require Carp;
			*{ $caller.'::'.$sub } = \&{ 'Carp::'.$sub };
			goto &{ 'Carp::'.$sub };
		};
	}
}

sub import {
	my $me = shift;
	my $caller = caller;
	local $^W;
	# use warnings
	${^WARNING_BITS} ^= ${^WARNING_BITS} ^ "\xfc\x3f\xf3\x00\x0f\xf3\xcf\xc0\xf3\xfc\x33\x03\x3f\x00\x0c\x00\x00\x00\x00";

	# use strict, utf8, open, 5.010, ...
	$^H |= 0x1c0206e2;

	# use feature qw(feature_say feature_state feature_indirect feature_switch)
	$^H{'feature_say'} = 1;
	$^H{'feature_state'} = 1;
	$^H{'feature_indirect'} = 1;
	$^H{'feature_switch'} = 1;

	no strict 'refs';
	for my $sub (qw(carp croak confess)) {
		*{ $caller .'::'. $sub } = \&$sub;
	}
	return if $caller =~ /^$me/;
	while (@_) {
		my $feature = shift;
		if ($feature =~ s/^://) {
			if (defined &{ $feature }) {
				*{ $caller .'::'. $feature } = \&$feature;
			} else {
				croak "Unknown feature: :$feature";
			}
		}
	}
	return;
}

sub unimport {
	my $me = shift;
	my $caller = caller;
	local $^W;
	# no warnings
	${^WARNING_BITS} = "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";

	# no strict, ...
	$^H &= ~0x1c0206e2;

	# no feature qw(feature_say feature_state feature_indirect feature_switch)
	delete $^H{'feature_say'};
	delete $^H{'feature_state'};
	delete $^H{'feature_indirect'};
	delete $^H{'feature_switch'};

	return;
}

sub xd ($;$) { no strict 'refs';
	if( eval{ require Devel::Hexdump; 1 }) { *{ caller().'::xd' } = \&Devel::Hexdump::xd; }
	else { *{ caller().'::xd' } = sub($;$) { my@a=unpack'(H2)*',$_[0];my$s='';
		$s .= "@a[ $_*16 .. $_*16 + 7 ]  @a[ $_*16+8 .. $_*16 + 15 ]\n" for (0..$#a/16);
		return $s;
	};}
	goto &{ caller().'::xd' };
}

sub dumper(@) {
	eval { require uni::dumper; 1} or goto &dumper_dd;
	no strict 'refs';
	*{ caller().'::dumper' } = \&uni::dumper::dumper;
	goto &{ caller().'::dumper' };
}

sub dumper_dd (@) {
	require Data::Dumper;
	no strict 'refs';
	*{ caller().'::dumper' } = sub (@) {
		my $s = Data::Dumper->new([@_])
			->Freezer('DUMPER_freeze')
			->Terse(1)
			->Indent(1)
			->Purity(0)
			->Useqq(1)
			->Quotekeys(0)
			->Dump;
		$s =~ s/\\x\{([a-f0-9]{1,4})\}/chr hex $1/sge;
		$s;
	};
	goto &{ caller().'::dumper' };
}

1;
